Description

There are lots of methods making use of the costly trimExplode method using a foreach loop on the exploded array immediately after
the method call.

The result is an array_map plus at least one (sometimes a second) foreach loop over the array of exploded items, one (or two) inside
the trimExplode and one outside over the resulting array. Performancewise foreach is not just faster in most of the cases but has a
much smaller memory footprint, so it would be a good idea to just stay with trimExplode when this is useful and necessary.

Since most of the cases don't make use of the limit parameter of trimExplode, we should replace any call to that method based on the
following rules:

    1. It must not be replaced when there is a limit in the original method call
    2. It must not be replaced when there is no foreach loop making use of the array immediately after the method call
    3. It must be replaced by at least a trim within the following loop
    4. It must be replaced by a trim AND a check for empty values within the following loop, when the third parameter was set to TRUE
before

Associated revisions
Revision 0d383257 - 2014-02-19 18:32 - Michiel Roos

[TASK] Optimize GeneralUtility::trimExplode()

This often used method can be about 5% more performant by rewriting it.

Change-Id: Iee80a35ebd98c3521a75977bc7ab45d170858e24
Resolves: #55198
Releases: 6.2
Reviewed-on: https://review.typo3.org/27086
Reviewed-by: Markus Klein
Tested-by: Markus Klein

History
#1 - 2014-01-22 09:03 - Michiel Roos

Here are some benchmarks http://pastebin.com/SZjWDDk9

2015-08-04 1/4

https://review.typo3.org/27086
http://pastebin.com/SZjWDDk9


preg_split is quite fast for 'most' cases.

We should indeed inspect all calls and see we actually need to trim the values.
The following methods do not handle whitespace:
    -  \TYPO3\CMS\Core\Utility\GeneralUtility::inList()
    -  \TYPO3\CMS\Core\Utility\GeneralUtility::rmFromList()
    -  \TYPO3\CMS\Core\Utility\GeneralUtility::expandList()

Code using these methods should not be calling trimExplode, but just plain explode.

I have not done any inspection yet.

#2 - 2014-01-28 09:55 - Ernesto Baschny
- Parent task set to #55078

#3 - 2014-01-28 10:10 - Gerrit Code Review
- Status changed from New to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/27086

#4 - 2014-01-28 10:17 - Gerrit Code Review

Patch set 2 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/27086

#5 - 2014-01-29 00:43 - Gerrit Code Review

Patch set 3 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/27086

#6 - 2014-01-31 02:22 - Gerrit Code Review

Patch set 4 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/27086

#7 - 2014-01-31 11:26 - Gerrit Code Review

Patch set 5 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/27086

#8 - 2014-01-31 11:45 - Gerrit Code Review

Patch set 6 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/27086
#9 - 2014-01-31 15:08 - Gerrit Code Review

Patch set 7 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/27086

#10 - 2014-01-31 18:49 - Gerrit Code Review

Patch set 8 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/27086

#11 - 2014-01-31 21:57 - Gerrit Code Review

Patch set 9 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/27086

#12 - 2014-02-01 00:00 - Gerrit Code Review

Patch set 10 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/27086

#13 - 2014-02-02 18:09 - Gerrit Code Review

Patch set 11 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/27086

#14 - 2014-02-03 11:47 - Gerrit Code Review

Patch set 12 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/27086

#15 - 2014-02-04 10:23 - Gerrit Code Review

Patch set 13 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/27086

#16 - 2014-02-04 11:04 - Gerrit Code Review

Patch set 14 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/27086

#17 - 2014-02-04 21:27 - Gerrit Code Review

Patch set 15 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/27086
#18 - 2014-02-04 22:40 - Gerrit Code Review

Patch set 16 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/27086

#19 - 2014-02-11 23:24 - Gerrit Code Review

Patch set 17 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/27086

#20 - 2014-02-17 16:52 - Gerrit Code Review

Patch set 18 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/27086

#21 - 2014-02-18 18:15 - Markus Klein

The title "Replace trimExplode + foreach with explode + trim within foreach" is not correct anymore, the patch does much less.

#22 - 2014-02-19 16:33 - Gerrit Code Review

Patch set 19 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/27086

#23 - 2014-02-19 19:30 - Michiel Roos
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:0d383257ba1a510da01b99f6408193b925d0fbaa.
